'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.LIGHT_HUES = exports.DARK_HUES = undefined;
exports.nearestHue = nearestHue;

var _lodash = require('lodash.minby');

var _lodash2 = _interopRequireDefault(_lodash);

var _lodash3 = require('lodash.pick');

var _lodash4 = _interopRequireDefault(_lodash3);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

var HUES = {
  red: 0,
  yellow: 60,
  green: 120,
  cyan: 180,
  blue: 240,
  magenta: 300
};
var DARK_HUES = exports.DARK_HUES = ['red', 'green', 'blue'];
var LIGHT_HUES = exports.LIGHT_HUES = ['yellow', 'cyan', 'magenta'];

function nearestHue(hue, variations) {
  var nearest = (0, _lodash2.default)(Object.keys(_lodash4.default.apply(undefined, [HUES].concat(_toConsumableArray(variations)))), function (h) {
    var phi = Math.abs(hue - HUES[h]) % 360;
    if (phi > 180) {
      return 360 - phi;
    }
    return phi;
  });
  return HUES[nearest];
}