'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.lowerLuminosity = lowerLuminosity;
exports.raiseLuminosity = raiseLuminosity;

var _hue = require('./hue');

var _math = require('./math');

function lowerLuminosity(hue, raiseAmount) {
  return shiftLuminosity(hue, raiseAmount, _hue.DARK_HUES);
}

function raiseLuminosity(hue, raiseAmount) {
  return shiftLuminosity(hue, raiseAmount, _hue.LIGHT_HUES);
}

function shiftLuminosity(hue, shiftAmount, huePoints) {
  if (hue === 360) {
    hue = 0;
  }
  var hueShift = (0, _hue.nearestHue)(hue, huePoints);
  var phi = (0, _math.PHI)(hue, hueShift);
  if (phi === 0) {
    return hue;
  }
  var newHue = void 0;
  if (phi > 0) {
    newHue = hue + shiftAmount;
  } else {
    newHue = hue - shiftAmount;
  }
  return (0, _math.limit)(newHue, 0, 360);
}