'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.darken = darken;
exports.lighten = lighten;

var _color = require('color');

var _color2 = _interopRequireDefault(_color);

var _luminosity = require('./luminosity');

var _modularscale = require('modularscale');

var _modularscale2 = _interopRequireDefault(_modularscale);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function darken(baseColor) {
  var _ref = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
      _ref$alpha = _ref.alpha,
      alpha = _ref$alpha === undefined ? null : _ref$alpha,
      _ref$format = _ref.format,
      format = _ref$format === undefined ? 'rgb' : _ref$format,
      scale = _ref.scale,
      _ref$steps = _ref.steps,
      steps = _ref$steps === undefined ? 0 : _ref$steps;

  if (!baseColor) {
    return baseColor;
  }
  var c = (0, _color2.default)(baseColor);
  var delta = (0, _modularscale2.default)(steps, scale) / 100;
  var newSaturation = c.saturationv() + c.saturationv() * delta;
  var newValue = c.value() - c.value() * delta;
  alpha = alpha || c.alpha();

  return c.hue((0, _luminosity.lowerLuminosity)(c.hue(), delta)).saturationv(newSaturation).value(newValue).alpha(alpha)[format]().string();
}

function lighten(baseColor) {
  var _ref2 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
      _ref2$alpha = _ref2.alpha,
      alpha = _ref2$alpha === undefined ? null : _ref2$alpha,
      _ref2$format = _ref2.format,
      format = _ref2$format === undefined ? 'rgb' : _ref2$format,
      scale = _ref2.scale,
      _ref2$steps = _ref2.steps,
      steps = _ref2$steps === undefined ? 0 : _ref2$steps;

  if (!baseColor) {
    return baseColor;
  }
  var c = (0, _color2.default)(baseColor);
  var delta = (0, _modularscale2.default)(steps, scale) / 100;
  var newSaturation = c.saturationv() - c.saturationv() * delta;
  var newValue = c.value() + c.value() * delta;
  alpha = alpha || c.alpha();

  return c.hue((0, _luminosity.raiseLuminosity)(c.hue(), delta)).saturationv(newSaturation).value(newValue).alpha(alpha)[format]().string();
}