import _Object$assign from 'babel-runtime/core-js/object/assign';
import _objectWithoutProperties from 'babel-runtime/helpers/objectWithoutProperties';
import { darken, lighten } from './variants';

/*
 * Convenience method for encapsulating the logic for generating a color
 * derivative used when an element is focused by the user
 */
export function focusColor(baseColor) {
  var _ref = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

  var _ref$steps = _ref.steps,
      steps = _ref$steps === undefined ? 5 : _ref$steps,
      opts = _objectWithoutProperties(_ref, ['steps']);

  return lighten(baseColor, _Object$assign({ steps: steps }, opts));
}

/*
 * Convenience method for encapsulating the logic for generating a color
 * derivative used when an element is hovered over by the user
 */
export function hoverColor(baseColor) {
  var _ref2 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

  var _ref2$steps = _ref2.steps,
      steps = _ref2$steps === undefined ? 5 : _ref2$steps,
      opts = _objectWithoutProperties(_ref2, ['steps']);

  return darken(baseColor, _Object$assign({ steps: steps }, opts));
}