import _toConsumableArray from 'babel-runtime/helpers/toConsumableArray';
import _Object$keys from 'babel-runtime/core-js/object/keys';
import minBy from 'lodash.minby';
import pick from 'lodash.pick';

// Max Hue points in 30-degree increments
var HUES = {
  /* eslint-disable sort-keys */
  red: 0,
  yellow: 60,
  green: 120,
  cyan: 180,
  blue: 240,
  magenta: 300
  /* eslint-enable sort-keys */
};
// Hues to shift towards to decrease perceived luminance
export var DARK_HUES = ['red', 'green', 'blue'];
// Hues to shift towards to increase perceived luminance
export var LIGHT_HUES = ['yellow', 'cyan', 'magenta'];

// Return the nearest max hue point for a given hue value
export function nearestHue(hue, variations) {
  var nearest = minBy(_Object$keys(pick.apply(undefined, [HUES].concat(_toConsumableArray(variations)))), function (h) {
    var phi = Math.abs(hue - HUES[h]) % 360;
    if (phi > 180) {
      return 360 - phi;
    }
    return phi;
  });
  return HUES[nearest];
}